<template>
    <div class="container-fluid">
        <div class="block-header">
            <a class="btn btn-primary waves-effect" @click="senderPage('addProduct')">
                <i class="material-icons">add</i>
                <span>Add New Product</span>
            </a>
        </div>
        <!-- Exportable Table -->
        <div class="row clearfix">
            <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                <div class="card">
                    <div class="header">
                        <h2>
                            ALL Product
                            <span class="badge bg-blue"></span>
                        </h2>
                    </div>
                    <div class="body">
                        <div class="table-responsive">
                            <table id="table" class="table table-striped table-bordered display nowrap" style="width:100%">
                                <thead>
                                <tr>
                                    <th>SL</th>
                                    <th>Image</th>
                                    <th>Product Name</th>
                                    <th>Product Code</th>
                                    <th>Category Name</th>
                                    <th>Sub Category Name</th>
                                    <th>Sub Sub Category Name</th>
                                    <th>Brand Name</th>
                                    <th>Sizes Name</th>
                                    <th>Colors Name</th>
                                    <th>Price</th>
                                    <th>Available</th>
                                    <th>Disable/Show</th>
                                    <th>Action</th>
                                </tr>
                                </thead>
                                <tfoot>
                                <tr>
                                    <th>SL</th>
                                    <th>Image</th>
                                    <th>Product Name</th>
                                    <th>Product Code</th>
                                    <th>Category Name</th>
                                    <th>Sub Category Name</th>
                                    <th>Sub Sub Category Name</th>
                                    <th>Brand Name</th>
                                    <th>Sizes Name</th>
                                    <th>Colors Name</th>
                                    <th>Price</th>
                                    <th>Available</th>
                                    <th>Disable/Show</th>
                                    <th>Action</th>
                                </tr>
                                </tfoot>
                                <tbody>
                                    <tr v-for="(product,key) in products" :key="product.id">
                                        <td>{{key+1}}</td>
                                        <td><img :src="'/storage/product/'+product.image" width="50px" height="50px" :alt="product.name"></td>
                                        <td>{{product.name}}</td>
                                        <td>{{product.code}}</td>
                                        <td>{{product.category.name}}</td>
                                        <td>{{product.sub_category.name}}</td>
                                        <td>{{product.sub_sub_category.name}}</td>
                                        <td>{{product.brand.name}}</td>
                                        <td><p v-for="size in product.sizes" :key="size.id">{{size.name}},</p></td>
                                        <td><p v-for="color in product.colors" :key="color.id">{{color.name}},</p></td>
                                        <td>{{product.price}}</td>
                                        <td width="10%">
                                            <div class="col-xs-12 col-sm-6 align-right">
                                                <div class="switch panel-switch-btn">
                                                    <label>
                                                        <input type="checkbox" :checked="product.is_available" @change="stockChange(product.id)">
                                                        <span class="lever switch-col-cyan"></span>
                                                    </label>
                                                </div>
                                            </div>
                                        </td>
                                        <td>
                                            <div class="col-xs-12 col-sm-6 align-right">
                                                <div class="switch panel-switch-btn">
                                                    <label>
                                                        <input type="checkbox" :checked="!product.is_disable" @change="enableDisable(product.id)">
                                                        <span class="lever switch-col-cyan"></span>
                                                    </label>
                                                </div>
                                            </div>
                                        </td>
                                        <td class="text-center">
                                            <a @click="edit(product)" href="javascript:void(0)" class="btn btn-info waves-effect">
                                                <i class="material-icons">edit</i>
                                            </a>
                                            <button class="btn btn-danger waves-effect" type="button" @click="deleteCategory(product.id)">
                                                <i class="material-icons">delete</i>
                                            </button>
                                        </td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- #END# Exportable Table -->
    </div>

</template>
<script>
 export default {
        data(){
            return {
                products:{},
                dataTableStatus:false,
            }
        },
        created() {
            this.getInfo();
        },
        methods:{
            /*
            * method for product information get
            * */
            getInfo(){
                axios.get('/admin/product').then((response)=>{
                    this.products=response.data;
                    if (this.dataTableStatus===false){
                        this.$nextTick(() => {
                            $("#table").DataTable({
                                dom: 'Blfrtip',
                                lengthChange: true,
                                buttons: [ 'copy', 'excel','csv', 'colvis' ],
                            });
                        });
                        this.dataTableStatus=true;
                    }
                }).catch((error)=>{
                    this.products={};
                });
            },
            /*
            * method for page change
            * */
            senderPage(text){
                this.$emit('sent',text);
            },
            /*
            * method for edit page redirect
            * */
            edit(text){
                this.$emit('edit',text);
                //console.log(data);
            },
            /*
            * method for remove product
            * */
            deleteCategory(product) {
                swal({
                    title: 'Are you sure?',
                    text: "You want to delete this!",
                    type: 'warning',
                    showCancelButton: true,
                    confirmButtonColor: '#3085d6',
                    cancelButtonColor: '#d33',
                    confirmButtonText: 'Yes, delete it!',
                    cancelButtonText: 'No, cancel!',
                    confirmButtonClass: 'btn btn-success',
                    cancelButtonClass: 'btn btn-danger',
                    buttonsStyling: false,
                    reverseButtons: true
                }).then((result) => {
                    if (result.value) {
                        axios.delete(`/admin/product/delete/${product}`).then((response)=>{
                            if(response.data[0]===0){
                                this.$toaster.error(response.data[1]);
                            }
                            else{
                                this.getInfo();
                                this.$toaster.success(response.data[1]);
                            }
                        });
                    } else if (
                        // Read more about handling dismissals
                        result.dismiss === swal.DismissReason.cancel
                    ) {
                        swal(
                            'Cancelled',
                            'Your data is safe :)',
                            'error'
                        )
                    }
                })
            },

            /*
            * method for product stock status change
            * */
            stockChange(product_id){
                axios.put(`/admin/product/available/status/change${product_id}`).then((response)=>{
                   this.$toaster.success(response.data);
                }).catch((error)=>{
                    this.$toaster.error(error);
                });
            },
            /*
            * method for product show or disable status maintain
            * */
            enableDisable(product_id){
                axios.put(`/admin/product/disable/status/change${product_id}`).then((response)=>{
                    this.$toaster.success(response.data);
                }).catch((error)=>{
                    this.$toaster.error(error);
                });
            }
        }
    }
</script>

